// IrrFontDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "IrrFont.h"
#include "IrrFontDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



/////////////////////////////////////////////////////////////////////////////
// CIrrFontDlg _CAO

CIrrFontDlg::CIrrFontDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CIrrFontDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CIrrFontDlg)
	m_fontface = _T("");
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CIrrFontDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CIrrFontDlg)
	DDX_Control(pDX, IDC_RICHEDIT_PREVIEW, m_preview);
	DDX_Control(pDX, IDC_COMBO, m_level);
	DDX_Text(pDX, IDC_EDIT_FACE, m_fontface);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CIrrFontDlg, CDialog)
	//{{AFX_MSG_MAP(CIrrFontDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_FONT, OnButtonFont)
	ON_BN_CLICKED(IDC_BUTTON_OUT_PUT, OnButtonOutPut)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CIrrFontDlg bZ[W nh

BOOL CIrrFontDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	// TODO: ʂȏs͂̏ꏊɒǉĂB

	//
	OnInit();
	
	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CIrrFontDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CIrrFontDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

//tHgύX{^
void CIrrFontDlg::OnButtonFont() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CFontDialog dlg(NULL, CF_SCREENFONTS | CF_INITTOLOGFONTSTRUCT, NULL, this);

	LOGFONT lf;
	lf.lfHeight		 = m_font.height;
	lf.lfWidth		  = 0;
	lf.lfEscapement	 = 0;
	lf.lfOrientation	= 0;
	lf.lfWeight		 = m_font.bold ? FW_BOLD : FW_NORMAL;
	lf.lfItalic		 = false;
	lf.lfUnderline	  = false;
	lf.lfStrikeOut	  = false;
	lf.lfCharSet		= SHIFTJIS_CHARSET;
	lf.lfOutPrecision   = OUT_DEFAULT_PRECIS;
	lf.lfClipPrecision  = CLIP_DEFAULT_PRECIS;
	lf.lfQuality		= DEFAULT_QUALITY;
	lf.lfPitchAndFamily = DEFAULT_PITCH | FF_DONTCARE;
	strcpy(lf.lfFaceName, m_font.face);

	dlg.m_cf.lpLogFont = &lf;

	if(dlg.DoModal() == IDOK)
	{
		m_font.face   = dlg.GetFaceName();
		m_font.height = dlg.GetSize() * 4 / 3 / 10;
		m_font.bold   = dlg.IsBold();

		UpdatePreview();
	}
}

//o̓{^
void CIrrFontDlg::OnButtonOutPut() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CFileDialog fd(FALSE, "bmp", NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
		"Windows Bitmap File(*.bmp)|*.bmp|All Files|*.*|\0", this);

	if(fd.DoModal() == IDOK)
	{
		if(OutputCore(fd.GetFileName()) == FALSE)
			AfxMessageBox("File Output Error!!");
	}
}

//
void CIrrFontDlg::OnInit()
{
	m_fontface = "lr SVbN";

	m_font.height = 16;
	m_font.bold   = false;
	m_font.face   = m_fontface;

	UpdatePreview();

	m_preview.SetWindowText("012345abcde");

	m_level.SetCurSel(0);

	UpdateData(FALSE);
}

//vr[ʂ̍XV
void CIrrFontDlg::UpdatePreview()
{
	m_fontface.Format("%s (%dpx %s)",
		m_font.face,
		m_font.height,
		m_font.bold? "" : "ʏ");
	UpdateData(FALSE);

	CHARFORMAT cf;

	m_preview.GetDefaultCharFormat(cf);

	cf.dwMask		  = CFM_BOLD| CFM_FACE| CFM_SIZE | CFM_CHARSET;
	cf.dwEffects	   = m_font.bold ? CFE_BOLD:0;
	cf.yHeight		 = m_font.height * 1440 / 96;
	cf.bCharSet		= DEFAULT_CHARSET;
	cf.bPitchAndFamily = FIXED_PITCH | FF_DONTCARE;
	strcpy(cf.szFaceName, m_font.face);

	m_preview.SetSel(0, -1);
	m_preview.SetSelectionCharFormat(cf);
	m_preview.SetDefaultCharFormat(cf);
}

//o̓C
BOOL CIrrFontDlg::OutputCore(LPCSTR szFileName)
{
	int lows, cols;
	int level = m_level.GetCurSel();
	int i;
	int sizeLists[8] = {16,32,64,128,256,512,1024,2048};

	switch(level)
	{
		case 0://ASCII At@xbg
			lows = 1;
			cols = 0x7E - 0x20 + 1;// + 0xDF - 0xA1 + 1;
			break;
		case 1://ꐅ܂
			lows = 1 + (0x98 - 0x81 + 1)*3;//1 + 0x98 - 0x81 + 1;
			cols = 128;//0x7E - 0x40 + 1 + 0xFC - 0x80 + 1;
			break;
	//	case 3://񐅏܂
	//		lows = 1 + 0x9F - 0x81 + 1 + 0xFC - 0xE0 + 1;
	//		cols = 0x7E - 0x40 + 1 + 0xFC - 0x80 + 1;
	//		break;
	}

	CDC dc;
	CDC FontDC;
	CBitmap FontBmp;
	dc.CreateCompatibleDC(GetDC());
	
	FontBmp.CreateCompatibleBitmap(&dc, 32,32);
	FontDC.CreateCompatibleDC(&dc);
	FontDC.SelectObject(&FontBmp);
	FontDC.SetTextColor(0xFFFFFF);
	FontDC.SetBkColor(0x000000);
	FontDC.SetBkMode(TRANSPARENT);


	//BMP쐬
	BITMAPINFO bi;
	bi.bmiHeader.biSize			= sizeof(BITMAPINFOHEADER);
	bi.bmiHeader.biWidth		= m_font.height * cols / 2;
	bi.bmiHeader.biHeight		= m_font.height * lows;
	bi.bmiHeader.biPlanes		= 1;
	bi.bmiHeader.biBitCount		= 24;
	bi.bmiHeader.biCompression	= BI_RGB;

	//BMPTCYDirectXpɏC
	for(i=0;i<8;i++)
	{
		if(bi.bmiHeader.biWidth <= sizeLists[i])
		{
			bi.bmiHeader.biWidth = sizeLists[i];
			break;
		}
	}
	for(i=0;i<8;i++)
	{
		if(bi.bmiHeader.biHeight <= sizeLists[i])
		{
			bi.bmiHeader.biHeight = sizeLists[i];
			break;
		}
	}

	WORD cClrBits = (WORD)(bi.bmiHeader.biPlanes * bi.bmiHeader.biBitCount); 
	if(cClrBits == 1) 
		cClrBits = 1; 
	else if(cClrBits <= 4) 
		cClrBits = 4; 
	else if(cClrBits <= 8) 
		cClrBits = 8; 
	else if(cClrBits <= 16) 
		cClrBits = 16; 
	else if(cClrBits <= 24) 
		cClrBits = 24; 
	else
		cClrBits = 32;
	bi.bmiHeader.biSizeImage = (bi.bmiHeader.biWidth + 7) / 8 
		* bi.bmiHeader.biHeight * cClrBits;
	bi.bmiHeader.biXPelsPerMeter = 0;
	bi.bmiHeader.biYPelsPerMeter = 0;
	bi.bmiHeader.biClrUsed	     = 0;
	bi.bmiHeader.biClrImportant  = 0;

	BYTE* pBits;
	HBITMAP hbmp = CreateDIBSection(dc, &bi, DIB_RGB_COLORS, (void**)&pBits, NULL, 0);

	::SelectObject(dc.m_hDC, hbmp);

	//tHg쐬
	CFont font;
	font.CreateFont(m_font.height,0,0,0,
		m_font.bold ? FW_BOLD : FW_NORMAL,FALSE,FALSE,FALSE,
		SHIFTJIS_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,
		DEFAULT_QUALITY,DEFAULT_PITCH, m_font.face);
	dc.SelectObject(font);

	//tHg`揀
	CBrush bg(RGB(0,0,0));
	dc.FillRect(CRect(0, 0, m_font.height * 256, m_font.height * 256), &bg);
	dc.SetTextColor(RGB(255, 255, 255));
	dc.SetBkMode(TRANSPARENT);
	dc.SetMapMode(MM_TEXT);
	FontDC.SelectObject(font);

	//`0FAXL[
	DrawFontASCII(&dc, &FontDC);

	//`1F1
	if(level >= 1)
		DrawFontLevel1(&dc, &FontDC);

	//`2F2
	if(level >= 2)
		DrawFontLevel2(&dc, &FontDC);

	//t@Cۑ
	if(SaveFile(szFileName, &bi.bmiHeader, pBits) == FALSE)
	{
		dc.DeleteDC();
		font.DeleteObject();
		::DeleteObject(hbmp);

		return FALSE;
	}

	//Еt
	dc.DeleteDC();
	font.DeleteObject();
	::DeleteObject(hbmp);
	FontDC.DeleteDC();
	FontBmp.DeleteObject();

	MessageBox("쐬܂","mF", MB_OK);

	return TRUE;
}

//t@Cɕۑ
BOOL CIrrFontDlg::SaveFile(LPCSTR szFileName, LPBITMAPINFOHEADER pbih, LPBYTE pBits)
{
	//save file
	HANDLE handle;
	BITMAPFILEHEADER head; 
	DWORD dwTmp; 

	handle = CreateFile(szFileName, GENERIC_READ | GENERIC_WRITE, (DWORD)0, 
		NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, (HANDLE)NULL); 
	if(handle == INVALID_HANDLE_VALUE)
	{
		TRACE("CeateFile Error\n");
		return FALSE;
	}

	head.bfType = 0x4d42; // 0x42 = "B" 0x4d = "M" 

	//t@CTCY̌vZ
	head.bfSize = (DWORD)(sizeof(BITMAPFILEHEADER) + pbih->biSize + pbih->biClrUsed * sizeof(RGBQUAD) + pbih->biSizeImage); 
	head.bfReserved1 = 0;
	head.bfReserved2 = 0;
	
	//ItZbǧvZ
	head.bfOffBits = (DWORD)sizeof(BITMAPFILEHEADER) + pbih->biSize + pbih->biClrUsed * sizeof(RGBQUAD);
	
	//BITMAPFILEHEADEȐ
	if(!WriteFile(handle, (LPVOID)&head, sizeof(BITMAPFILEHEADER), &dwTmp,  NULL))
	{
		TRACE("WriteFile Error\n");
		return FALSE;
	}
	
	//BITMAPINFOHEADERRGBQUAD̏
	if(!WriteFile(handle, (LPVOID)pbih, sizeof(BITMAPINFOHEADER) + pbih->biClrUsed * sizeof(RGBQUAD), (LPDWORD)&dwTmp, NULL))
	{
		TRACE("WriteFile Error\n");
		return FALSE;
	}

	//J[̏
	DWORD cb = pbih->biSizeImage;
	if(!WriteFile(handle, pBits, (int)cb, &dwTmp, NULL))
	{
		TRACE("WriteFile Error\n");
		return FALSE;
	}
	
	//Еt
	if(!CloseHandle(handle)) 
	{
		TRACE("CloseHandle Error\n");
		return FALSE;
	}

	return TRUE;
}

//ASCII`
void CIrrFontDlg::DrawFontASCII(CDC *pDC, CDC *pfDC)
{
	BYTE tmp[2] = {0,0};
	int w = m_font.height / 2;
	POINT size = {m_font.height/2, m_font.height};

	//At@xbg̕`(0x20-0x7F)
	for(int x = 0; x <= 0x7E - 0x20; x++)
	{
		//tmp[0] = 0x20;
		tmp[0] = x + 0x20;
		pDC->TextOut(x * w, 0, (char*)tmp, 1);
	}
}

//ꐅ`	0x8140-0x987F
void CIrrFontDlg::DrawFontLevel1(CDC *pDC, CDC *pfDC)
{
	BYTE tmp[3] = {0,0,0};
	int x, y, w = m_font.height;
	POINT size = {w, m_font.height};
	int px=0, py=0;
	
	for(y=0;y<=0x98-0x81;y++)
	{
		px = 0;
		py = 0;
		for(x=0x40;x<=0xFC;x++)//8140-81FC
		{
			tmp[0] = y + 0x81;
			tmp[1] = x;
			pDC->TextOut(px * w, (y*3 + 1 + py) * w, (char*)tmp, 2);
			px++;
			if(px == 64){
				px = 0;
				py++;
			}
		}
	}

	//pJiŌɒǉ 20071016
	pDC->FillSolidRect(0,(y*3 +1 + py -3) * w,1024,w,0x000000);
	for(x = 0xA0; x <= 0xDF; x++)
	{
		tmp[0] = x;
		pDC->TextOut((x-0xA0) * w/2, (y*3 +1 + py -3) * w, (char*)tmp, 1);
	}
}

//񐅏`	0x9880-0xFCFF
//̂܂܂ł͑1̕ƏdȂ̂ŌŒ
void CIrrFontDlg::DrawFontLevel2(CDC *pDC, CDC *pfDC)
{
	BYTE tmp[2] = {0, 0};
	int x, y, w = m_font.height;
	POINT size = {w, m_font.height};
	
	for(x=0;x<=0xFC-0x9F;x++)
	{
		tmp[0] = 0x98;
		tmp[1] = x + 0x9F;
		pDC->TextOut((x + 0x7E - 0x40 + 0x9F - 0x80 + 1) * w, (0x98 - 0x81 + 1) * w, (char*)tmp, 2);
	}
	for(y=0;y<=0x9F-0x99;y++)
	{
		for(x=0;x<=0x7E-0x40;x++)
		{
			tmp[0] = y + 0x99;
			tmp[1] = x + 0x40;
			pDC->TextOut(x * w, (y + 0x99 - 0x81 + 1) * w, (char*)tmp, 2);
		}
		for(x=0;x<=0xFC-0x80;x++)
		{
			tmp[0] = y + 0x99;
			tmp[1] = x + 0x80;
			pDC->TextOut((x + 0x7E - 0x40 + 1) * w, (y + 0x99 - 0x81 + 1) * w, (char*)tmp, 2);
		}
	}
	for(y=0;y<=0xFC-0xE0;y++)
	{
		for(x=0;x<=0x7E-0x40;x++)
		{
			tmp[0] = y + 0xE0;
			tmp[1] = x + 0x40;
			pDC->TextOut(x * w, (y + 0x9F - 0x81 + 1 + 1) * w, (char*)tmp, 2);
		}
		for(x=0;x<=0xFC-0x80;x++)
		{
			tmp[0] = y + 0xE0;
			tmp[1] = x + 0x80;
			pDC->TextOut((x + 0x7E - 0x40 + 1) * w, (y + 0x9F - 0x81 + 1 + 1) * w, (char*)tmp, 2);
		}
	}
}
